"use strict";

var _User = require("../__mocks__/User");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

describe('mocks/UserTC', () => {
  it('UserTC should have `count` resolver',
  /*#__PURE__*/
  _asyncToGenerator(function* () {
    const cnt = yield _User.UserTC.getResolver('count').resolve({});
    expect(cnt).toBe(15);
  }));
  it('UserTC should have `findMany` resolver',
  /*#__PURE__*/
  _asyncToGenerator(function* () {
    const res = yield _User.UserTC.getResolver('findMany').resolve({});
    expect(res).toHaveLength(15);
  }));
  it('UserTC should have `findMany` resolver with working `filter` arg',
  /*#__PURE__*/
  _asyncToGenerator(function* () {
    const res = yield _User.UserTC.getResolver('findMany').resolve({
      args: {
        filter: {
          gender: 'm'
        }
      },
      rawQuery: {
        age: {
          $gt: 15,
          $lt: 20
        },
        id: {
          $gt: 8,
          $lt: 20
        }
      }
    });
    expect(res).toEqual([{
      id: 9,
      name: 'user09',
      age: 19,
      gender: 'm'
    }]);
  }));
  it('UserTC should have `findMany` resolver with working `sort` arg',
  /*#__PURE__*/
  _asyncToGenerator(function* () {
    const res = yield _User.UserTC.getResolver('findMany').resolve({
      args: {
        sort: {
          age: -1,
          id: -1
        },
        limit: 5
      }
    });
    expect(res).toEqual([{
      id: 11,
      name: 'user11',
      age: 49,
      gender: 'm'
    }, {
      id: 10,
      name: 'user10',
      age: 49,
      gender: 'f'
    }, {
      id: 12,
      name: 'user12',
      age: 47,
      gender: 'f'
    }, {
      id: 15,
      name: 'user15',
      age: 45,
      gender: 'm'
    }, {
      id: 14,
      name: 'user14',
      age: 45,
      gender: 'm'
    }]);
  }));
});