"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.composeWithPagination = composeWithPagination;

var _graphqlCompose = require("graphql-compose");

var _paginationResolver = require("./paginationResolver");

function composeWithPagination(typeComposer, opts) {
  if (!typeComposer || typeComposer.constructor.name !== 'ObjectTypeComposer') {
    throw new Error('You should provide ObjectTypeComposer instance to composeWithPagination method');
  }

  if (!opts) {
    throw new Error('You should provide non-empty options to composeWithPagination');
  }

  const resolverName = opts.paginationResolverName || _paginationResolver.DEFAULT_RESOLVER_NAME;

  if (typeComposer.hasResolver(resolverName)) {
    return typeComposer;
  }

  const resolver = (0, _paginationResolver.preparePaginationResolver)(typeComposer, opts);
  typeComposer.setResolver(resolverName, resolver);
  return typeComposer;
}